Index: /pjproject/trunk/pjmedia/include/pjmedia-codec/config.h
===================================================================
--- /pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 4050)
+++ /pjproject/trunk/pjmedia/include/pjmedia-codec/config.h	(revision 4051)
@@ -379,10 +379,20 @@
 
 /**
+ * Specify if FFMPEG codecs are available.
+ *
+ * Default: PJMEDIA_HAS_LIBAVCODEC
+ */
+#ifndef PJMEDIA_HAS_FFMPEG_CODEC
+#   define PJMEDIA_HAS_FFMPEG_CODEC		PJMEDIA_HAS_LIBAVCODEC
+#endif
+
+
+/**
  * Specify if FFMPEG video codecs are available.
  *
- * Default: PJMEDIA_HAS_LIBAVCODEC
+ * Default: PJMEDIA_HAS_FFMPEG_CODEC
  */
 #ifndef PJMEDIA_HAS_FFMPEG_VID_CODEC
-#   define PJMEDIA_HAS_FFMPEG_VID_CODEC		PJMEDIA_HAS_LIBAVCODEC
+#   define PJMEDIA_HAS_FFMPEG_VID_CODEC		PJMEDIA_HAS_FFMPEG_CODEC
 #endif
 
Index: /pjproject/trunk/pjsip-apps/src/samples/aviplay.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/aviplay.c	(revision 4050)
+++ /pjproject/trunk/pjsip-apps/src/samples/aviplay.c	(revision 4051)
@@ -501,6 +501,6 @@
     }
     
-#if PJMEDIA_HAS_FFMPEG_CODEC
-    status = pjmedia_codec_ffmpeg_init(NULL, &cp.factory);
+#if PJMEDIA_HAS_FFMPEG_VID_CODEC
+    status = pjmedia_codec_ffmpeg_vid_init(NULL, &cp.factory);
     if (status != PJ_SUCCESS)
 	goto on_return;    
@@ -519,6 +519,6 @@
 
 on_return:    
-#if PJMEDIA_HAS_FFMPEG_CODEC
-    pjmedia_codec_ffmpeg_deinit();
+#if PJMEDIA_HAS_FFMPEG_VID_CODEC
+    pjmedia_codec_ffmpeg_vid_deinit();
 #endif
     pjmedia_aud_subsys_shutdown();
Index: /pjproject/trunk/pjsip-apps/src/samples/simpleua.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/simpleua.c	(revision 4050)
+++ /pjproject/trunk/pjsip-apps/src/samples/simpleua.c	(revision 4051)
@@ -386,9 +386,9 @@
     PJ_ASSERT_RETURN(status == PJ_SUCCESS, 1);
 
-#  if defined(PJMEDIA_HAS_FFMPEG_CODEC) && PJMEDIA_HAS_FFMPEG_CODEC!=0
+#  if defined(PJMEDIA_HAS_FFMPEG_VID_CODEC) && PJMEDIA_HAS_FFMPEG_VID_CODEC!=0
     /* Init ffmpeg video codecs */
-    status = pjmedia_codec_ffmpeg_init(NULL, &cp.factory);
-    PJ_ASSERT_RETURN(status == PJ_SUCCESS, 1);
-#  endif  /* PJMEDIA_HAS_FFMPEG_CODEC */
+    status = pjmedia_codec_ffmpeg_vid_init(NULL, &cp.factory);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, 1);
+#  endif  /* PJMEDIA_HAS_FFMPEG_VID_CODEC */
 
 #endif	/* PJMEDIA_HAS_VIDEO */
@@ -574,6 +574,6 @@
 
     /* Deinit ffmpeg codec */
-#   if defined(PJMEDIA_HAS_FFMPEG_CODEC) && PJMEDIA_HAS_FFMPEG_CODEC!=0
-    pjmedia_codec_ffmpeg_deinit();
+#   if defined(PJMEDIA_HAS_FFMPEG_VID_CODEC) && PJMEDIA_HAS_FFMPEG_VID_CODEC!=0
+    pjmedia_codec_ffmpeg_vid_deinit();
 #   endif
 
Index: /pjproject/trunk/pjsip-apps/src/samples/vid_streamutil.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/samples/vid_streamutil.c	(revision 4050)
+++ /pjproject/trunk/pjsip-apps/src/samples/vid_streamutil.c	(revision 4051)
@@ -122,6 +122,6 @@
     PJ_UNUSED_ARG(status);
 
-#if defined(PJMEDIA_HAS_FFMPEG_CODEC) && PJMEDIA_HAS_FFMPEG_CODEC != 0
-    status = pjmedia_codec_ffmpeg_init(NULL, pf);
+#if defined(PJMEDIA_HAS_FFMPEG_VID_CODEC) && PJMEDIA_HAS_FFMPEG_VID_CODEC != 0
+    status = pjmedia_codec_ffmpeg_vid_init(NULL, pf);
     PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
 #endif
@@ -135,6 +135,6 @@
 static void deinit_codecs()
 {
-#if defined(PJMEDIA_HAS_FFMPEG_CODEC) && PJMEDIA_HAS_FFMPEG_CODEC != 0
-    pjmedia_codec_ffmpeg_deinit();
+#if defined(PJMEDIA_HAS_FFMPEG_VID_CODEC) && PJMEDIA_HAS_FFMPEG_VID_CODEC != 0
+    pjmedia_codec_ffmpeg_vid_deinit();
 #endif
 }
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 4050)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 4051)
@@ -74,6 +74,6 @@
     }
 
-#if PJMEDIA_HAS_VIDEO && PJMEDIA_HAS_FFMPEG_CODEC
-    status = pjmedia_codec_ffmpeg_init(NULL, &pjsua_var.cp.factory);
+#if PJMEDIA_HAS_VIDEO && PJMEDIA_HAS_FFMPEG_VID_CODEC
+    status = pjmedia_codec_ffmpeg_vid_init(NULL, &pjsua_var.cp.factory);
     if (status != PJ_SUCCESS) {
 	PJ_PERROR(1,(THIS_FILE, status,
@@ -130,6 +130,6 @@
     pjmedia_vid_dev_subsys_shutdown();
 
-#if PJMEDIA_HAS_FFMPEG_CODEC
-    pjmedia_codec_ffmpeg_deinit();
+#if PJMEDIA_HAS_FFMPEG_VID_CODEC
+    pjmedia_codec_ffmpeg_vid_deinit();
 #endif
 